		/*       */
#include <io1200.h>	//  
#include "macros.h"

#define led	PD0	// 
#define out	PD1	//  
#define MAX  50		//     
#define MIN  10		//     
#define TRUE 1
#define FALSE 0
#define osc 1200	//  
#define led_on ((PORTD)|=1<<(PD0))	// 
#define led_off ((PORTD)&=~(1<<(PD0)))	// 
#define out_on ((PORTD)|=1<<(PD1))	// 
#define out_off ((PORTD)&=~(1<<(PD1)))	// 

void pause(unsigned int time)	/*   */
{				// T=time X 16,3  1/Fosc=4
	while(time-->0);	// 16- 
}

void tim0Ovf()	/*   /,       */
{	}

void init()		/*  */
{
 	 CLI();			//  
	 DDRD=0x07;		//   D
	 PORTD=0x00;		//  
	 DDRB=0xFF;		//   
	 PORTB=0x00;		//   		
	 ACSR=0x80;		//  
	 MCUCR=0x20;		//    
	 TIMSK=0x02;		//    / 0
}

char scan_rc5(void)	/*      */
{
 	unsigned char temp;	//   
	TCNT0=0x00;		// /
	pause(0x30D4);		// 0,1 
	temp=TCNT0;		//  /
	if(temp>MIN && temp<MAX)//         
	{
	 	return TRUE;	// ,    TRUE
	}
	return FALSE;		// ,  - FALSE
}

void main(void)		/* */
{
  	unsigned char temp, out_flag=0, led_flag=1, led_counter=1;
	
	pause(osc);		// 
	init();			// 
	
	while(1)		/*    */
	{
	 		/**/
		TCCR0=0x05;	//    1:1024
		TCNT0=0x00;	// / 0
		TIFR=0xFF;	//     
		SEI();		//    
		asm("sleep");	//............
	/*   (0,13),   */
		CLI();		//  
		TCCR0=0xFF;	//  / 0   
	
	/*       */ 	
		if(scan_rc5()==1)	//      
		{			// , 
			if(out_flag==1)	//    
				{	//   
				 	out_off;	// 
				 	led_on;		// 
					led_counter=1;	//   
					led_flag=1;	//   
					out_flag=0;	//   ""
				}
				else	// ,  
				{
				 	out_on;		// 
				 	led_off;	// 
					led_flag=0;	//  
					out_flag=1;	//   ""
				}			 
			for(temp=0;temp<2;temp++)	// 1
			{
			 	pause(0xFFFF);		//  0,5
			}
		}

	/*       */ 	
		if(led_flag==1)		//    
		{			
		 	led_counter--;		// ,     
			if(led_counter==0)	//     "0"	
			{
			 	if((PIND&BIT(led))==1)	//        
				{
				 	led_off;		// 
					led_counter=12;		//   
				}
				else
				{
				 	led_on;			// 
					led_counter=2;		//  
				}
			}
		}
	}
}	 				 